package com.skr.mdm.service.impl.content;

import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONUtil;
import com.baomidou.mybatisplus.extension.conditions.update.LambdaUpdateChainWrapper;
import com.skr.mdm.annotation.CmdHandler;
import com.skr.mdm.constant.CmdTypeConstants;
import com.skr.mdm.dao.ContentDocumentUserDao;
import com.skr.mdm.dto.DocumentInfoDTO;
import com.skr.mdm.entity.ContentDocumentUserDO;
import com.skr.mdm.result.ResponseResult;
import com.skr.mdm.service.CmdHandlerService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.ArrayList;
import java.util.List;

/**
 * @author nfq
 * @date 2020/8/3 15:14
 */
@Slf4j
@CmdHandler(cmdType = CmdTypeConstants.DOCUMENT_ISSUE)
public class DocumentManageServiceImpl implements CmdHandlerService {

    @Autowired
    private ContentDocumentUserDao documentUserDao;

    @Override
    public ResponseResult cmdHandler(Integer equipmentId, String data) {
        try {
            // 文档管理回调
            JSONArray jsonArray = JSONUtil.parseArray(data);
            List<DocumentInfoDTO> documentInfoDTOList = JSONUtil.toList(jsonArray, DocumentInfoDTO.class);
            List<Integer> cidList = new ArrayList<>(documentInfoDTOList.size());
            documentInfoDTOList.forEach(documentInfoDTO -> {
                LambdaUpdateChainWrapper<ContentDocumentUserDO> updateChainWrapper = new LambdaUpdateChainWrapper<>(documentUserDao);
                updateChainWrapper
                        .set(ContentDocumentUserDO::getState, documentInfoDTO.getState())
                        .eq(ContentDocumentUserDO::getFileId, documentInfoDTO.getFileId())
                        .eq(ContentDocumentUserDO::getEquipmentId, equipmentId)
                        .update();
                cidList.add(documentInfoDTO.getCid());
            });
            return ResponseResult.success(JSONUtil.toJsonStr(cidList));
        } catch (Exception e) {
            log.error("文档管理回调异常: " + equipmentId + data, e);
            return ResponseResult.failure();
        }
    }
}
